#include <iostream>

#include "server_thread.h"

using namespace hellomodule;

server_thread::server_thread ()
{
  glib_thread = Glib::Thread::create (sigc::mem_fun(this,
						    &server_thread::thread_consumer),
				      true);

}


server_thread::~server_thread ()
{

}



void server_thread::thread_consumer (void)
{
  // This is where each Thread spends its life
  while (1)
    {
      {
	Glib::Mutex::Lock lock (thread_mutex_);

	while (queue_.empty ())
        {
	  activity_.wait (thread_mutex_);
        }

	Hello_ptr thread_work = queue_.front ();
	queue_.pop ();

	std::cerr << "Thread picked up work\n" ;

	// XXX: The call that kills things ...
	thread_work->ping ();
      }

    }
}


void server_thread::queue (Hello_ptr work)
{
  {
    Glib::Mutex::Lock lock (thread_mutex_);

    queue_.push (work);

    activity_.signal ();
  }

  return;
}
